
;CodeVisionAVR C Compiler V2.04.4a Advanced
;(C) Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega8535L
;Program type             : Application
;Clock frequency          : 16,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 128 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8535L
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 512
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer2_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer0_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_0x1A:
	.DB  0x81,0xF3,0x49,0x61,0x33,0x25,0x5,0xF1
	.DB  0x1,0x21,0xD,0x5F,0xFF

__GLOBAL_INI_TBL:
	.DW  0x0D
	.DW  _sym
	.DW  _0x1A*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xE0)
	LDI  R29,HIGH(0xE0)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0xE0

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.04.4a Advanced
;Automatic Program Generator
; Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 03.10.2010
;Author  : NeVaDa
;Company : Microsoft
;Comments:
;
;
;Chip type               : ATmega8535L
;Program type            : Application
;AVR Core Clock frequency: 16,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 128
;*****************************************************/
;
;#include <mega8535.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;
;#include <delay.h>
;/*
;// 1 Wire Bus functions
;#asm
;   .equ __w1_port=0x18 ;PORTB
;   .equ __w1_bit=4
;#endasm
;#include <1wire.h>
;#include <ds1820.h>
;#define MAX_DS1820 8
;volatile unsigned char ds1820_devices;
;volatile unsigned char ds1820_rom_codes[MAX_DS1820][9];
;*/
;//eeprom volatile unsigned char rejim_eep;//       0  ,
;//eeprom volatile unsigned char zadanie_I_eep; //      
;//eeprom volatile unsigned char zadanie_U_eep; //      
;volatile unsigned char start1;//   5   
;volatile unsigned char soft_start;//  
;volatile unsigned char rejim;//       0  ,
;                                    //1   
;                                    //2  
;                                    //3   
;volatile unsigned char zadanie_I; //    
;volatile unsigned char I_ADC;      //   I
;volatile unsigned char izmerenoe_I;//        
;volatile unsigned char zadanie_U; //    
;volatile unsigned char U_ADC;      //   U
;volatile unsigned char izmerenoe_U;//        
;volatile unsigned char start;      //    0   , 1  
;volatile unsigned char indy_I;//         
;volatile unsigned char indy_U;//         
;/********************************* ***************************************************************/
;void start_310 (void){//       
; 0000 003A void start_310 (void){

	.CSEG
_start_310:
; 0000 003B delay_ms (20);      // 2       
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 003C PORTB.0=1;            //   
	SBI  0x18,0
; 0000 003D if (zadanie_I==0){    //    0
	RCALL SUBOPT_0x0
	CPI  R30,0
	BRNE _0x5
; 0000 003E zadanie_I=1;          //    
	LDI  R30,LOW(1)
	STS  _zadanie_I,R30
; 0000 003F //zadanie_I_eep=zadanie_I;
; 0000 0040 }
; 0000 0041 if (zadanie_U==0){    //    0
_0x5:
	RCALL SUBOPT_0x1
	CPI  R30,0
	BRNE _0x6
; 0000 0042 zadanie_U=1;          //    
	LDI  R30,LOW(1)
	STS  _zadanie_U,R30
; 0000 0043 //zadanie_U_eep=zadanie_U;
; 0000 0044 }
; 0000 0045 delay_ms (5);       // 0,5 
_0x6:
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0046 TCCR2=0x6E;         //  2    
	LDI  R30,LOW(110)
	OUT  0x25,R30
; 0000 0047 }
	RET
;/*******************************************************************************************************************/
;/*************************************   250 *****************************************************/
;interrupt [TIM2_OVF] void timer2_ovf_isr(void)
; 0000 004B {
_timer2_ovf_isr:
	ST   -Y,R0
	ST   -Y,R26
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0000 004C start1++;
	LDS  R30,_start1
	SUBI R30,-LOW(1)
	STS  _start1,R30
; 0000 004D if (start1==5){// start1  ==5
	LDS  R26,_start1
	CPI  R26,LOW(0x5)
	BRNE _0x7
; 0000 004E soft_start++;  //  soft_start  1
	RCALL SUBOPT_0x2
	SUBI R30,-LOW(1)
	STS  _soft_start,R30
; 0000 004F start1=0;      // start1
	LDI  R30,LOW(0)
	STS  _start1,R30
; 0000 0050 }
; 0000 0051 if (rejim==0 || rejim==1 & soft_start<zadanie_I){//         
_0x7:
	RCALL SUBOPT_0x3
	CPI  R26,LOW(0x0)
	BREQ _0x9
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x5
	RCALL __LTB12U
	AND  R30,R0
	BREQ _0x8
_0x9:
; 0000 0052 OCR2=soft_start;                                 //  
	RCALL SUBOPT_0x6
; 0000 0053 }
; 0000 0054 if (rejim==2 || rejim==3 && soft_start<zadanie_U){//         
_0x8:
	RCALL SUBOPT_0x3
	CPI  R26,LOW(0x2)
	BREQ _0xC
	RCALL SUBOPT_0x3
	CPI  R26,LOW(0x3)
	BRNE _0xD
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x5
	CP   R26,R30
	BRLO _0xC
_0xD:
	RJMP _0xB
_0xC:
; 0000 0055 OCR2=soft_start;                                 //  
	RCALL SUBOPT_0x6
; 0000 0056 }
; 0000 0057 if (OCR2==zadanie_I || OCR2==zadanie_U){//      
_0xB:
	IN   R30,0x23
	MOV  R26,R30
	RCALL SUBOPT_0x0
	CP   R30,R26
	BREQ _0x11
	IN   R30,0x23
	MOV  R26,R30
	RCALL SUBOPT_0x1
	CP   R30,R26
	BRNE _0x10
_0x11:
; 0000 0058 TIMSK=0x01;//      2      0 "00000001"
	LDI  R30,LOW(1)
	OUT  0x39,R30
; 0000 0059 TCCR0=0x03;//   0         250 
	LDI  R30,LOW(3)
	OUT  0x33,R30
; 0000 005A start=1;//   
	LDI  R30,LOW(1)
	STS  _start,R30
; 0000 005B }
; 0000 005C }
_0x10:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	LD   R26,Y+
	LD   R0,Y+
	RETI
;/*******************************************************************************************************************/
;/****************************  0 250 ***********************************************************/
;volatile unsigned int divider_500;//  500 500   
;volatile unsigned char divider_indy;//    
;volatile long int divider_125000;//  125000 0,5
;volatile unsigned int divider_2500;//  2500 100   
;volatile unsigned char divider_button;//  
;volatile unsigned int divider_250;//  250 1000   
;volatile unsigned char divider_pulse;//   500
;interrupt [TIM0_OVF] void timer0_ovf_isr(void){
; 0000 0066 interrupt [10] void timer0_ovf_isr(void){
_timer0_ovf_isr:
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0067 divider_500++;
	LDI  R26,LOW(_divider_500)
	LDI  R27,HIGH(_divider_500)
	RCALL SUBOPT_0x7
; 0000 0068 if (divider_500==500){
	LDS  R26,_divider_500
	LDS  R27,_divider_500+1
	CPI  R26,LOW(0x1F4)
	LDI  R30,HIGH(0x1F4)
	CPC  R27,R30
	BRNE _0x13
; 0000 0069 divider_500=0;
	LDI  R30,LOW(0)
	STS  _divider_500,R30
	STS  _divider_500+1,R30
; 0000 006A divider_indy=1;
	LDI  R30,LOW(1)
	STS  _divider_indy,R30
; 0000 006B }
; 0000 006C divider_125000++;
_0x13:
	LDI  R26,LOW(_divider_125000)
	LDI  R27,HIGH(_divider_125000)
	RCALL __GETD1P_INC
	__SUBD1N -1
	RCALL __PUTDP1_DEC
; 0000 006D if (divider_125000==125000){
	LDS  R26,_divider_125000
	LDS  R27,_divider_125000+1
	LDS  R24,_divider_125000+2
	LDS  R25,_divider_125000+3
	__CPD2N 0x1E848
	BRNE _0x14
; 0000 006E divider_125000=0;
	LDI  R30,LOW(0)
	STS  _divider_125000,R30
	STS  _divider_125000+1,R30
	STS  _divider_125000+2,R30
	STS  _divider_125000+3,R30
; 0000 006F }
; 0000 0070 divider_2500++;
_0x14:
	LDI  R26,LOW(_divider_2500)
	LDI  R27,HIGH(_divider_2500)
	RCALL SUBOPT_0x7
; 0000 0071 if (divider_2500==25){
	LDS  R26,_divider_2500
	LDS  R27,_divider_2500+1
	SBIW R26,25
	BRNE _0x15
; 0000 0072 divider_2500=0;
	LDI  R30,LOW(0)
	STS  _divider_2500,R30
	STS  _divider_2500+1,R30
; 0000 0073 divider_button=1;
	LDI  R30,LOW(1)
	STS  _divider_button,R30
; 0000 0074 }
; 0000 0075 divider_250++;
_0x15:
	LDI  R26,LOW(_divider_250)
	LDI  R27,HIGH(_divider_250)
	RCALL SUBOPT_0x7
; 0000 0076 if (divider_250==125){
	RCALL SUBOPT_0x8
	CPI  R26,LOW(0x7D)
	LDI  R30,HIGH(0x7D)
	CPC  R27,R30
	BRNE _0x16
; 0000 0077 divider_pulse=1;
	LDI  R30,LOW(1)
	STS  _divider_pulse,R30
; 0000 0078 }
; 0000 0079 if (divider_250==250){
_0x16:
	RCALL SUBOPT_0x8
	CPI  R26,LOW(0xFA)
	LDI  R30,HIGH(0xFA)
	CPC  R27,R30
	BRNE _0x17
; 0000 007A divider_pulse=0;
	LDI  R30,LOW(0)
	STS  _divider_pulse,R30
; 0000 007B }
; 0000 007C }
_0x17:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	RETI
;/*******************************************************************************************************************/
;/*************************************   *******************************************
;interrupt [ANA_COMP] void ana_comp_isr(void){//    
;TCCR2=0x00;                                  //  2  
;start=0;                                     // 
;}
;*******************************************************************************************************************/
;/****************************************************************************************************************/
;//  ADC6  
;volatile unsigned char calculator_bufer_I[4]={0,0,0,0};//    
;volatile unsigned char calculator_bufer_U[4]={0,0,0,0};//    
;void ADC_I (void){ //  ADC6
; 0000 0088 void ADC_I (void){
_ADC_I:
; 0000 0089 ADMUX=0b00100110;
	LDI  R30,LOW(38)
	RCALL SUBOPT_0x9
; 0000 008A ADCSRA=0b11000001;// 2
; 0000 008B delay_us(8);
; 0000 008C I_ADC=ADCH;
	STS  _I_ADC,R30
; 0000 008D calculator_bufer_I[3]=calculator_bufer_I[2];
	__GETB1MN _calculator_bufer_I,2
	__PUTB1MN _calculator_bufer_I,3
; 0000 008E calculator_bufer_I[2]=calculator_bufer_I[1];
	__GETB1MN _calculator_bufer_I,1
	__PUTB1MN _calculator_bufer_I,2
; 0000 008F calculator_bufer_I[1]=calculator_bufer_I[0];
	LDS  R30,_calculator_bufer_I
	__PUTB1MN _calculator_bufer_I,1
; 0000 0090 calculator_bufer_I[0]=I_ADC;
	LDS  R30,_I_ADC
	STS  _calculator_bufer_I,R30
; 0000 0091 izmerenoe_I=(calculator_bufer_I[3]+calculator_bufer_I[2]+calculator_bufer_I[1]+calculator_bufer_I[0])/4;
	__GETB2MN _calculator_bufer_I,3
	CLR  R27
	__GETB1MN _calculator_bufer_I,2
	RCALL SUBOPT_0xA
	__GETB1MN _calculator_bufer_I,1
	RCALL SUBOPT_0xA
	LDS  R30,_calculator_bufer_I
	RCALL SUBOPT_0xA
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RCALL __DIVW21
	STS  _izmerenoe_I,R30
; 0000 0092 indy_I=izmerenoe_I;
	RCALL SUBOPT_0xB
; 0000 0093 }
	RET
;//  ADC7  
;void ADC_U (void){ //  ADC7
; 0000 0095 void ADC_U (void){
_ADC_U:
; 0000 0096 ADMUX=0b00100111;
	LDI  R30,LOW(39)
	RCALL SUBOPT_0x9
; 0000 0097 ADCSRA=0b11000001;// 2
; 0000 0098 delay_us(8);
; 0000 0099 U_ADC=ADCH;
	STS  _U_ADC,R30
; 0000 009A calculator_bufer_U[3]=calculator_bufer_U[2];
	__GETB1MN _calculator_bufer_U,2
	__PUTB1MN _calculator_bufer_U,3
; 0000 009B calculator_bufer_U[2]=calculator_bufer_U[1];
	__GETB1MN _calculator_bufer_U,1
	__PUTB1MN _calculator_bufer_U,2
; 0000 009C calculator_bufer_U[1]=calculator_bufer_U[0];
	LDS  R30,_calculator_bufer_U
	__PUTB1MN _calculator_bufer_U,1
; 0000 009D calculator_bufer_U[0]=U_ADC;
	LDS  R30,_U_ADC
	STS  _calculator_bufer_U,R30
; 0000 009E izmerenoe_U=(calculator_bufer_U[3]+calculator_bufer_U[2]+calculator_bufer_U[1]+calculator_bufer_U[0])/4;
	__GETB2MN _calculator_bufer_U,3
	CLR  R27
	__GETB1MN _calculator_bufer_U,2
	RCALL SUBOPT_0xA
	__GETB1MN _calculator_bufer_U,1
	RCALL SUBOPT_0xA
	LDS  R30,_calculator_bufer_U
	RCALL SUBOPT_0xA
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	RCALL __DIVW21
	STS  _izmerenoe_U,R30
; 0000 009F indy_U=izmerenoe_U;
	RCALL SUBOPT_0xC
; 0000 00A0 }
	RET
;/*******************************************************************************************************************/
;/******************************************** ***********************************************************/
;// 
;void PWM_control_I (void){
; 0000 00A4 void PWM_control_I (void){
_PWM_control_I:
; 0000 00A5 if ((izmerenoe_I < zadanie_I) & soft_start<255){//     soft_start<255
	RCALL SUBOPT_0x0
	LDS  R26,_izmerenoe_I
	RCALL __LTB12U
	MOV  R0,R30
	RCALL SUBOPT_0x5
	LDI  R30,LOW(255)
	RCALL __LTB12U
	AND  R30,R0
	BREQ _0x18
; 0000 00A6 soft_start++;                                 // 
	RCALL SUBOPT_0x2
	SUBI R30,-LOW(1)
	STS  _soft_start,R30
; 0000 00A7 OCR2=soft_start;                              //        
	RCALL SUBOPT_0x6
; 0000 00A8 }
; 0000 00A9 if ((izmerenoe_I > zadanie_I) & soft_start>0){//     soft_start>0
_0x18:
	RCALL SUBOPT_0x0
	LDS  R26,_izmerenoe_I
	RCALL __GTB12U
	MOV  R0,R30
	RCALL SUBOPT_0x5
	LDI  R30,LOW(0)
	RCALL __GTB12U
	AND  R30,R0
	BREQ _0x19
; 0000 00AA soft_start--;                               // 
	RCALL SUBOPT_0x2
	SUBI R30,LOW(1)
	STS  _soft_start,R30
; 0000 00AB OCR2=soft_start;                            //        
	RCALL SUBOPT_0x6
; 0000 00AC }
; 0000 00AD }
_0x19:
	RET
;/*// 
;void PWM_control_U (void){
;volatile unsigned char control_U;//      
;control_U=izmerenoe_U;
;if (izmerenoe_U < zadanie_U){
;control_U++;
;OCR2=control_U;
;}
;if (izmerenoe_U > zadanie_U){
;control_U--;
;OCR2=control_U;
;}
;}
;*/
;/*******************************************************************************************************************/
;/******************************************* **************************************************/
;/*********************   *******
;              a
;            -----
;          f|     |b
;           |  g  |
;            -----
;          e|     |c
;           |  d  |
;            ----- *h
;g      f      e      d      c      b      a      in
;p7    p6    p5    p4    p3    p2    p1    p0
;**********************************************************************/
;#define dig1I PORTA.2//PORTD.5         dig1I
;#define dig2I PORTA.1//PORTD.6         dig2I
;#define dig3I PORTA.0//PORTD.7        dig3I
;#define dig1U PORTA.5//PORTD.5         dig1U
;#define dig2U PORTA.4//PORTD.6         dig2U
;#define dig3U PORTA.3//PORTD.7        dig3U
;unsigned char sym[]={
;0b10000001, //(0)0
;0b11110011, //(1)1
;0b01001001, //(2)2
;0b01100001, //(3)3
;0b00110011, //(4)4
;0b00100101, //(5)5
;0b00000101, //(6)6
;0b11110001, //(7)7
;0b00000001, //(8)8
;0b00100001, //(9)9
;0b00001101, //(10)E
;0b01011111, //(11)r
;0b11111111  //(12)  
;};

	.DSEG
;
;volatile unsigned char cur_dig;//  
;volatile unsigned char sym_out[6];// sym_out   ( 6)        
;volatile unsigned char indy_static_I;//         
;volatile unsigned char indy_static_U;//         
;/*****************************************************************/
;void recoding (void){
; 0000 00E5 void recoding (void){

	.CSEG
_recoding:
; 0000 00E6 /****************** *****************************/
; 0000 00E7 if (divider_indy==1){
	LDS  R26,_divider_indy
	CPI  R26,LOW(0x1)
	BREQ PC+2
	RJMP _0x1B
; 0000 00E8 indy_static_I=indy_I;
	LDS  R30,_indy_I
	STS  _indy_static_I,R30
; 0000 00E9 indy_static_U=indy_U;
	LDS  R30,_indy_U
	STS  _indy_static_U,R30
; 0000 00EA if (indy_static_I<255){              //  indication  255
	LDS  R26,_indy_static_I
	CPI  R26,LOW(0xFF)
	BRSH _0x1C
; 0000 00EB indy_I=izmerenoe_I;                  //indy_I  izmerenoe_I  divider_1000  1
	RCALL SUBOPT_0xB
; 0000 00EC sym_out[0]=indy_I%10;                //  sym_out 0       
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0xE
	STS  _sym_out,R30
; 0000 00ED indy_I=indy_I/10;                    //  indication      380  38
	RCALL SUBOPT_0xF
; 0000 00EE sym_out[1]=indy_I%10;                //  8   
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0xE
	__PUTB1MN _sym_out,1
; 0000 00EF indy_I=indy_I/10;                    // 38  3
	RCALL SUBOPT_0xF
; 0000 00F0 sym_out[2]=indy_I;                   //    3
	LDS  R30,_indy_I
	RJMP _0xD7
; 0000 00F1 }
; 0000 00F2 else                              // 
_0x1C:
; 0000 00F3 {
; 0000 00F4 sym_out[0]=11;                   //
	LDI  R30,LOW(11)
	STS  _sym_out,R30
; 0000 00F5 sym_out[1]=10;                   //Er
	LDI  R30,LOW(10)
	__PUTB1MN _sym_out,1
; 0000 00F6 sym_out[2]=12;                   // 0   
	LDI  R30,LOW(12)
_0xD7:
	__PUTB1MN _sym_out,2
; 0000 00F7 }
; 0000 00F8 /****************** **********************/
; 0000 00F9 if (indy_static_U<255){  //  indication  255
	LDS  R26,_indy_static_U
	CPI  R26,LOW(0xFF)
	BRSH _0x1E
; 0000 00FA indy_U=izmerenoe_U;      //indy_U  izmerenoe_U
	RCALL SUBOPT_0xC
; 0000 00FB sym_out[3]=indy_U%10;    //  sym_out 0       
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0xE
	__PUTB1MN _sym_out,3
; 0000 00FC indy_U=indy_U/10;        //  indication      380  38
	RCALL SUBOPT_0x11
; 0000 00FD sym_out[4]=indy_U%10;    //  8   
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0xE
	__PUTB1MN _sym_out,4
; 0000 00FE indy_U=indy_U/10;        // 38  3
	RCALL SUBOPT_0x11
; 0000 00FF sym_out[5]=indy_U;       //    3
	LDS  R30,_indy_U
	RJMP _0xD8
; 0000 0100 }
; 0000 0101 else                     // 
_0x1E:
; 0000 0102 {
; 0000 0103 sym_out[3]=11;           //
	LDI  R30,LOW(11)
	__PUTB1MN _sym_out,3
; 0000 0104 sym_out[4]=10;           //Er
	LDI  R30,LOW(10)
	__PUTB1MN _sym_out,4
; 0000 0105 sym_out[5]=12;           // 0   
	LDI  R30,LOW(12)
_0xD8:
	__PUTB1MN _sym_out,5
; 0000 0106 }
; 0000 0107 
; 0000 0108 /**********     ********************/
; 0000 0109 PORTC=sym[12];                                                         //  C
	__GETB1MN _sym,12
	OUT  0x15,R30
; 0000 010A switch (cur_dig){                                                      //   
	RCALL SUBOPT_0x12
; 0000 010B case 0:{dig1I=1; dig2I=0; dig3I=0; dig1U=0; dig2U=0; dig3U=0; break;}; //    1 
	SBIW R30,0
	BRNE _0x23
	SBI  0x1B,2
	CBI  0x1B,1
	CBI  0x1B,0
	RCALL SUBOPT_0x13
	RJMP _0x22
; 0000 010C case 1:{dig2I=1; dig3I=0; dig1I=0; dig1U=0; dig2U=0; dig3U=0; break;}; //    2 
_0x23:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x30
	SBI  0x1B,1
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x13
	RJMP _0x22
; 0000 010D case 2:{dig3I=1; dig1I=0; dig2I=0; dig1U=0; dig2U=0; dig3U=0; break;}; //    3 
_0x30:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x3D
	SBI  0x1B,0
	CBI  0x1B,2
	CBI  0x1B,1
	RCALL SUBOPT_0x13
	RJMP _0x22
; 0000 010E case 3:{dig1U=1; dig3I=0; dig1I=0; dig2I=0; dig2U=0; dig3U=0; break;}; //    1 
_0x3D:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x4A
	SBI  0x1B,5
	RCALL SUBOPT_0x14
	CBI  0x1B,1
	CBI  0x1B,4
	CBI  0x1B,3
	RJMP _0x22
; 0000 010F case 4:{dig2U=1; dig1U=0; dig3I=0; dig1I=0; dig2I=0; dig3U=0; break;}; //    2 
_0x4A:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x57
	SBI  0x1B,4
	CBI  0x1B,5
	RCALL SUBOPT_0x14
	CBI  0x1B,1
	CBI  0x1B,3
	RJMP _0x22
; 0000 0110 case 5:{dig3U=1; dig2U=0; dig1U=0; dig3I=0; dig1I=0; dig2I=0; break;}; //    3 
_0x57:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x22
	SBI  0x1B,3
	CBI  0x1B,4
	CBI  0x1B,5
	RCALL SUBOPT_0x14
	CBI  0x1B,1
; 0000 0111 }
_0x22:
; 0000 0112 
; 0000 0113 if (indy_static_I<10){                 //  adc_dataI<10
	LDS  R26,_indy_static_I
	CPI  R26,LOW(0xA)
	BRSH _0x71
; 0000 0114 dig2I=0; dig1I=0;                          // 2  
	CBI  0x1B,1
	CBI  0x1B,2
; 0000 0115 }
; 0000 0116 if (indy_static_I<100){                //  adc_dataI<100
_0x71:
	LDS  R26,_indy_static_I
	CPI  R26,LOW(0x64)
	BRSH _0x76
; 0000 0117 dig2I=0;                                   // 1  
	CBI  0x1B,1
; 0000 0118 }
; 0000 0119 if (indy_static_U<10){                //  adc_dataI<10
_0x76:
	LDS  R26,_indy_static_U
	CPI  R26,LOW(0xA)
	BRSH _0x79
; 0000 011A dig2U=0; dig1U=0;                         // 2  
	CBI  0x1B,4
	CBI  0x1B,5
; 0000 011B }
; 0000 011C if (indy_static_U<100){               //  adc_dataI<100
_0x79:
	LDS  R26,_indy_static_U
	CPI  R26,LOW(0x64)
	BRSH _0x7E
; 0000 011D dig2U=0;                                  // 1  
	CBI  0x1B,4
; 0000 011E }
; 0000 011F if (divider_indy==1){
_0x7E:
	LDS  R26,_divider_indy
	CPI  R26,LOW(0x1)
	BRNE _0x81
; 0000 0120 PORTC=sym[sym_out[cur_dig]];              //   C   
	RCALL SUBOPT_0x12
	SUBI R30,LOW(-_sym_out)
	SBCI R31,HIGH(-_sym_out)
	LD   R30,Z
	RCALL SUBOPT_0x15
	SUBI R30,LOW(-_sym)
	SBCI R31,HIGH(-_sym)
	LD   R30,Z
	OUT  0x15,R30
; 0000 0121 cur_dig=cur_dig+1;                        //  cur_dig  1
	LDS  R30,_cur_dig
	SUBI R30,-LOW(1)
	STS  _cur_dig,R30
; 0000 0122 if (cur_dig==6){
	LDS  R26,_cur_dig
	CPI  R26,LOW(0x6)
	BRNE _0x82
; 0000 0123  cur_dig=0;                               //  cur_dig     5
	LDI  R30,LOW(0)
	STS  _cur_dig,R30
; 0000 0124 }
; 0000 0125 }
_0x82:
; 0000 0126 }
_0x81:
; 0000 0127 divider_indy=0;                          //    
_0x1B:
	LDI  R30,LOW(0)
	STS  _divider_indy,R30
; 0000 0128 }
	RET
;/*******************************************************************************************************************/
;/*************************************************************************************************************/
;void button (void){
; 0000 012B void button (void){
_button:
; 0000 012C #define b_bolshe PIND.0                                       // 
; 0000 012D #define b_menshe PIND.1                                       // 
; 0000 012E #define b_rejim PIND.2                                        //  
; 0000 012F #define b_parametr PIND.3                                     //  
; 0000 0130 float koficient;                                               //      
; 0000 0131 if (divider_button==1){                                        //  100    
	SBIW R28,4
;	koficient -> Y+0
	LDS  R26,_divider_button
	CPI  R26,LOW(0x1)
	BREQ PC+2
	RJMP _0x83
; 0000 0132 if (b_rejim==0 && b_bolshe==1 && b_menshe==1 && b_parametr==1){//    
	LDI  R26,0
	SBIC 0x10,2
	LDI  R26,1
	CPI  R26,LOW(0x0)
	BRNE _0x85
	SBIS 0x10,0
	RJMP _0x85
	SBIS 0x10,1
	RJMP _0x85
	SBIC 0x10,3
	RJMP _0x86
_0x85:
	RJMP _0x84
_0x86:
; 0000 0133 rejim++;                                                       //   
	LDS  R30,_rejim
	SUBI R30,-LOW(1)
	STS  _rejim,R30
; 0000 0134 if (rejim==4){                                                 // 
	RCALL SUBOPT_0x3
	CPI  R26,LOW(0x4)
	BRNE _0x87
; 0000 0135 rejim=0;                                                       //   3 
	LDI  R30,LOW(0)
	STS  _rejim,R30
; 0000 0136 }
; 0000 0137 }
_0x87:
; 0000 0138 if (b_bolshe==0 && b_menshe==1 && b_rejim==1 && b_parametr==1 && rejim==0 || rejim==1){//         
_0x84:
	RCALL SUBOPT_0x16
	BRNE _0x89
	SBIS 0x10,1
	RJMP _0x89
	SBIS 0x10,2
	RJMP _0x89
	SBIS 0x10,3
	RJMP _0x89
	RCALL SUBOPT_0x3
	CPI  R26,LOW(0x0)
	BREQ _0x8B
_0x89:
	RCALL SUBOPT_0x3
	CPI  R26,LOW(0x1)
	BRNE _0x88
_0x8B:
; 0000 0139 zadanie_I++;
	RCALL SUBOPT_0x0
	SUBI R30,-LOW(1)
	RCALL SUBOPT_0x17
; 0000 013A koficient=zadanie_I/1.275;
; 0000 013B indy_I=(unsigned char)koficient;
; 0000 013C }
; 0000 013D if (b_menshe==0 && b_bolshe==0 && b_parametr==1 && b_rejim==1 && rejim==0 || rejim==1){//         
_0x88:
	RCALL SUBOPT_0x18
	BRNE _0x8E
	RCALL SUBOPT_0x16
	BRNE _0x8E
	SBIS 0x10,3
	RJMP _0x8E
	SBIS 0x10,2
	RJMP _0x8E
	RCALL SUBOPT_0x3
	CPI  R26,LOW(0x0)
	BREQ _0x90
_0x8E:
	RCALL SUBOPT_0x3
	CPI  R26,LOW(0x1)
	BRNE _0x8D
_0x90:
; 0000 013E zadanie_I--;
	RCALL SUBOPT_0x0
	SUBI R30,LOW(1)
	RCALL SUBOPT_0x17
; 0000 013F koficient=zadanie_I/1.275;
; 0000 0140 indy_I=(unsigned char)koficient;
; 0000 0141 }
; 0000 0142 if (b_bolshe==0 && b_menshe==1 && b_rejim==1 && b_parametr==1 && rejim==2 || rejim==3){//         
_0x8D:
	RCALL SUBOPT_0x16
	BRNE _0x93
	SBIS 0x10,1
	RJMP _0x93
	SBIS 0x10,2
	RJMP _0x93
	SBIS 0x10,3
	RJMP _0x93
	RCALL SUBOPT_0x3
	CPI  R26,LOW(0x2)
	BREQ _0x95
_0x93:
	RCALL SUBOPT_0x3
	CPI  R26,LOW(0x3)
	BRNE _0x92
_0x95:
; 0000 0143 zadanie_U++;
	RCALL SUBOPT_0x1
	SUBI R30,-LOW(1)
	RCALL SUBOPT_0x19
; 0000 0144 koficient=zadanie_U/1.275;
; 0000 0145 indy_U=(unsigned char)koficient;
; 0000 0146 }
; 0000 0147 if (b_menshe==0 && b_bolshe==0 && b_parametr==1 && b_rejim==1 && rejim==2 || rejim==3){//         
_0x92:
	RCALL SUBOPT_0x18
	BRNE _0x98
	RCALL SUBOPT_0x16
	BRNE _0x98
	SBIS 0x10,3
	RJMP _0x98
	SBIS 0x10,2
	RJMP _0x98
	RCALL SUBOPT_0x3
	CPI  R26,LOW(0x2)
	BREQ _0x9A
_0x98:
	RCALL SUBOPT_0x3
	CPI  R26,LOW(0x3)
	BRNE _0x97
_0x9A:
; 0000 0148 zadanie_U--;
	RCALL SUBOPT_0x1
	SUBI R30,LOW(1)
	RCALL SUBOPT_0x19
; 0000 0149 koficient=zadanie_U/1.275;
; 0000 014A indy_U=(unsigned char)koficient;
; 0000 014B }
; 0000 014C }
_0x97:
; 0000 014D divider_button=0;//   
_0x83:
	LDI  R30,LOW(0)
	STS  _divider_button,R30
; 0000 014E }
	ADIW R28,4
	RET
;/*******************************************************************************************************************/
;/**********************************************************************************************************/
;#define l_pad PORTD.4
;#define l_pad_pulse PORTD.5
;#define l_jest PORTD.6
;#define l_jest_pulse PORTB.5
;#define l_alarm PORTB.7
;void led_rejim (void){
; 0000 0156 void led_rejim (void){
_led_rejim:
; 0000 0157 switch (rejim){
	LDS  R30,_rejim
	RCALL SUBOPT_0x15
; 0000 0158 case 0:{l_pad=0; l_pad_pulse=1; l_jest=1; l_jest_pulse=1; break;};
	SBIW R30,0
	BRNE _0x9F
	CBI  0x12,4
	SBI  0x12,5
	SBI  0x12,6
	SBI  0x18,5
	RJMP _0x9E
; 0000 0159 case 1:{l_pad_pulse=0; l_pad=1; l_jest=1; l_jest_pulse=1; break;};
_0x9F:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0xA8
	CBI  0x12,5
	SBI  0x12,4
	SBI  0x12,6
	SBI  0x18,5
	RJMP _0x9E
; 0000 015A case 2:{l_jest=0; l_pad_pulse=1; l_pad=1; l_jest_pulse=1; break;};
_0xA8:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0xB1
	CBI  0x12,6
	SBI  0x12,5
	SBI  0x12,4
	SBI  0x18,5
	RJMP _0x9E
; 0000 015B case 3:{l_jest_pulse=0; l_jest=1; l_pad_pulse=1; l_pad=1; break;};
_0xB1:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x9E
	CBI  0x18,5
	SBI  0x12,6
	SBI  0x12,5
	SBI  0x12,4
; 0000 015C }
_0x9E:
; 0000 015D }
	RET
;/*******************************************************************************************************************/
;/**************************************** **********************************************************/
;
;/*******************************************************************************************************************/
;
;void main(void)
; 0000 0164 {
_main:
; 0000 0165 // Declare your local variables here
; 0000 0166 
; 0000 0167 // Input/Output Ports initialization
; 0000 0168 // Port A initialization
; 0000 0169 // Func7=In Func6=In Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 016A // State7=T State6=T State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
; 0000 016B PORTA=0x00;
	LDI  R30,LOW(0)
	OUT  0x1B,R30
; 0000 016C DDRA=0x3F;
	LDI  R30,LOW(63)
	OUT  0x1A,R30
; 0000 016D 
; 0000 016E // Port B initialization
; 0000 016F // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 0170 // State7=1 State6=1 State5=1 State4=0 State3=0 State2=0 State1=0 State0=0
; 0000 0171 PORTB=0xE0;
	LDI  R30,LOW(224)
	OUT  0x18,R30
; 0000 0172 DDRB=0xFF;
	LDI  R30,LOW(255)
	OUT  0x17,R30
; 0000 0173 
; 0000 0174 // Port C initialization
; 0000 0175 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 0176 // State7=1 State6=1 State5=1 State4=1 State3=1 State2=1 State1=1 State0=1
; 0000 0177 PORTC=0xFF;
	OUT  0x15,R30
; 0000 0178 DDRC=0xFF;
	OUT  0x14,R30
; 0000 0179 
; 0000 017A // Port D initialization
; 0000 017B // Func7=Out Func6=Out Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In
; 0000 017C // State7=0 State6=1 State5=1 State4=1 State3=P State2=P State1=P State0=P
; 0000 017D PORTD=0x7F;
	LDI  R30,LOW(127)
	OUT  0x12,R30
; 0000 017E DDRD=0xF0;
	LDI  R30,LOW(240)
	OUT  0x11,R30
; 0000 017F 
; 0000 0180 // Timer/Counter 0 initialization
; 0000 0181 // Clock source: System Clock
; 0000 0182 // Clock value: Timer 0 Stopped
; 0000 0183 // Mode: Normal top=FFh
; 0000 0184 // OC0 output: Disconnected
; 0000 0185 TCCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x33,R30
; 0000 0186 TCNT0=0x00;
	OUT  0x32,R30
; 0000 0187 OCR0=0x00;
	OUT  0x3C,R30
; 0000 0188 
; 0000 0189 // Timer/Counter 1 initialization
; 0000 018A // Clock source: System Clock
; 0000 018B // Clock value: Timer1 Stopped
; 0000 018C // Mode: Normal top=FFFFh
; 0000 018D // OC1A output: Discon.
; 0000 018E // OC1B output: Discon.
; 0000 018F // Noise Canceler: Off
; 0000 0190 // Input Capture on Falling Edge
; 0000 0191 // Timer1 Overflow Interrupt: Off
; 0000 0192 // Input Capture Interrupt: Off
; 0000 0193 // Compare A Match Interrupt: Off
; 0000 0194 // Compare B Match Interrupt: Off
; 0000 0195 TCCR1A=0x00;
	OUT  0x2F,R30
; 0000 0196 TCCR1B=0x00;
	OUT  0x2E,R30
; 0000 0197 TCNT1H=0x00;
	OUT  0x2D,R30
; 0000 0198 TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 0199 ICR1H=0x00;
	OUT  0x27,R30
; 0000 019A ICR1L=0x00;
	OUT  0x26,R30
; 0000 019B OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 019C OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 019D OCR1BH=0x00;
	OUT  0x29,R30
; 0000 019E OCR1BL=0x00;
	OUT  0x28,R30
; 0000 019F 
; 0000 01A0 // Timer/Counter 2 initialization
; 0000 01A1 // Clock source: System Clock
; 0000 01A2 // Clock value: Timer2 Stopped
; 0000 01A3 // Mode: Normal top=FFh
; 0000 01A4 // OC2 output: Disconnected
; 0000 01A5 ASSR=0x00;
	OUT  0x22,R30
; 0000 01A6 TCCR2=0x00;
	OUT  0x25,R30
; 0000 01A7 TCNT2=0x00;
	OUT  0x24,R30
; 0000 01A8 OCR2=0x00;
	OUT  0x23,R30
; 0000 01A9 
; 0000 01AA // External Interrupt(s) initialization
; 0000 01AB // INT0: Off
; 0000 01AC // INT1: Off
; 0000 01AD // INT2: Off
; 0000 01AE MCUCR=0x00;
	OUT  0x35,R30
; 0000 01AF MCUCSR=0x00;
	OUT  0x34,R30
; 0000 01B0 
; 0000 01B1 // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 01B2 TIMSK=0x40;
	LDI  R30,LOW(64)
	OUT  0x39,R30
; 0000 01B3 
; 0000 01B4 // Analog Comparator initialization
; 0000 01B5 // Analog Comparator: On
; 0000 01B6 // The Analog Comparator's positive input is
; 0000 01B7 // connected to the Bandgap Voltage Reference
; 0000 01B8 // Interrupt on Falling Output Edge
; 0000 01B9 // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 01BA //ACSR=0x4A;
; 0000 01BB ACSR=0x00;
	LDI  R30,LOW(0)
	OUT  0x8,R30
; 0000 01BC SFIOR=0x00;
	OUT  0x30,R30
; 0000 01BD 
; 0000 01BE /*** ADC initialization
; 0000 01BF // ADC Clock frequency: 1000,000 kHz
; 0000 01C0 // ADC Voltage Reference: AREF pin
; 0000 01C1 // ADC High Speed Mode: Off
; 0000 01C2 // ADC Auto Trigger Source: Free Running
; 0000 01C3 // Only the 8 most significant bits of
; 0000 01C4 // the AD conversion result are used
; 0000 01C5 ADMUX=ADC_VREF_TYPE & 0xff;
; 0000 01C6 ADCSRA=0xA4;
; 0000 01C7 SFIOR&=0x0F;
; 0000 01C8 ***/
; 0000 01C9 // Determine the number of DS1820 devices
; 0000 01CA // connected to the 1 Wire bus
; 0000 01CB //ds1820_devices=w1_search(0xf0,ds1820_rom_codes);
; 0000 01CC 
; 0000 01CD // Global enable interrupts
; 0000 01CE #asm("sei")
	sei
; 0000 01CF /*******************************************************************************************************************/
; 0000 01D0 start_310();
	RCALL _start_310
; 0000 01D1 while (1){
_0xC3:
; 0000 01D2 /************************ ******************************************************************************/
; 0000 01D3 while (start==1 & rejim==0){//        
_0xC6:
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x3
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x1B
	BREQ _0xC8
; 0000 01D4 ADC_I();                     //  
	RCALL SUBOPT_0x1C
; 0000 01D5 PWM_control_I();             //    
; 0000 01D6 ADC_U();                     // 
; 0000 01D7 recoding ();                 //    
; 0000 01D8 button();                    // 
; 0000 01D9 led_rejim();                 //     
; 0000 01DA }
	RJMP _0xC6
_0xC8:
; 0000 01DB /************************  ******************************************************************/
; 0000 01DC while (start==1 & rejim==1){//         
_0xC9:
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x3
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x1B
	BREQ _0xCB
; 0000 01DD if (divider_pulse==1){       //  
	LDS  R26,_divider_pulse
	CPI  R26,LOW(0x1)
	BRNE _0xCC
; 0000 01DE if (TCCR2==0x00){            //  
	IN   R30,0x25
	CPI  R30,0
	BRNE _0xCD
; 0000 01DF TCCR2=0x6E;                  //  
	LDI  R30,LOW(110)
	OUT  0x25,R30
; 0000 01E0 }
; 0000 01E1 ADC_I();                     //  
_0xCD:
	RCALL SUBOPT_0x1C
; 0000 01E2 PWM_control_I();             //    
; 0000 01E3 ADC_U();                     // 
; 0000 01E4 recoding ();                 //    
; 0000 01E5 button();                    // 
; 0000 01E6 led_rejim();                 //     
; 0000 01E7 }
; 0000 01E8 if (divider_pulse==0){       // 
_0xCC:
	LDS  R30,_divider_pulse
	CPI  R30,0
	BRNE _0xCE
; 0000 01E9 if (TCCR2==0x6E){            //  
	IN   R30,0x25
	CPI  R30,LOW(0x6E)
	BRNE _0xCF
; 0000 01EA TCCR2=0x00;                  //  
	LDI  R30,LOW(0)
	OUT  0x25,R30
; 0000 01EB }
; 0000 01EC recoding ();                 //    
_0xCF:
	RCALL _recoding
; 0000 01ED button();                    // 
	RCALL _button
; 0000 01EE led_rejim();                 //     
	RCALL _led_rejim
; 0000 01EF }
; 0000 01F0 }
_0xCE:
	RJMP _0xC9
_0xCB:
; 0000 01F1 /*********************** ***********************************************************************/
; 0000 01F2 while (start==1 & rejim==2){//        
_0xD0:
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x3
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x1B
	BREQ _0xD2
; 0000 01F3 button();                    // 
	RCALL _button
; 0000 01F4 led_rejim();                 //     
	RCALL _led_rejim
; 0000 01F5 }
	RJMP _0xD0
_0xD2:
; 0000 01F6 /************************  ************************************************************/
; 0000 01F7 while (start==1 & rejim==3){//         
_0xD3:
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x3
	LDI  R30,LOW(3)
	RCALL SUBOPT_0x1B
	BREQ _0xD5
; 0000 01F8 button();                    // 
	RCALL _button
; 0000 01F9 led_rejim();                 //     
	RCALL _led_rejim
; 0000 01FA }
	RJMP _0xD3
_0xD5:
; 0000 01FB }
	RJMP _0xC3
; 0000 01FC 
; 0000 01FD 
; 0000 01FE 
; 0000 01FF 
; 0000 0200 
; 0000 0201 
; 0000 0202 
; 0000 0203 }
_0xD6:
	RJMP _0xD6

	.DSEG
_start1:
	.BYTE 0x1
_soft_start:
	.BYTE 0x1
_rejim:
	.BYTE 0x1
_zadanie_I:
	.BYTE 0x1
_I_ADC:
	.BYTE 0x1
_izmerenoe_I:
	.BYTE 0x1
_zadanie_U:
	.BYTE 0x1
_U_ADC:
	.BYTE 0x1
_izmerenoe_U:
	.BYTE 0x1
_start:
	.BYTE 0x1
_indy_I:
	.BYTE 0x1
_indy_U:
	.BYTE 0x1
_divider_500:
	.BYTE 0x2
_divider_indy:
	.BYTE 0x1
_divider_125000:
	.BYTE 0x4
_divider_2500:
	.BYTE 0x2
_divider_button:
	.BYTE 0x1
_divider_250:
	.BYTE 0x2
_divider_pulse:
	.BYTE 0x1
_calculator_bufer_I:
	.BYTE 0x4
_calculator_bufer_U:
	.BYTE 0x4
_sym:
	.BYTE 0xD
_cur_dig:
	.BYTE 0x1
_sym_out:
	.BYTE 0x6
_indy_static_I:
	.BYTE 0x1
_indy_static_U:
	.BYTE 0x1

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x0:
	LDS  R30,_zadanie_I
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1:
	LDS  R30,_zadanie_U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x2:
	LDS  R30,_soft_start
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 17 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x3:
	LDS  R26,_rejim
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x4:
	LDI  R30,LOW(1)
	RCALL __EQB12
	MOV  R0,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5:
	LDS  R26,_soft_start
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6:
	RCALL SUBOPT_0x2
	OUT  0x23,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x7:
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x8:
	LDS  R26,_divider_250
	LDS  R27,_divider_250+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x9:
	OUT  0x7,R30
	LDI  R30,LOW(193)
	OUT  0x6,R30
	__DELAY_USB 43
	IN   R30,0x5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0xA:
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xB:
	LDS  R30,_izmerenoe_I
	STS  _indy_I,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xC:
	LDS  R30,_izmerenoe_U
	STS  _indy_U,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xD:
	LDS  R26,_indy_I
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xE:
	CLR  R27
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xF:
	RCALL SUBOPT_0xD
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21
	STS  _indy_I,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x10:
	LDS  R26,_indy_U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x11:
	RCALL SUBOPT_0x10
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21
	STS  _indy_U,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x12:
	LDS  R30,_cur_dig
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x13:
	CBI  0x1B,5
	CBI  0x1B,4
	CBI  0x1B,3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x14:
	CBI  0x1B,0
	CBI  0x1B,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x15:
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x16:
	LDI  R26,0
	SBIC 0x10,0
	LDI  R26,1
	CPI  R26,LOW(0x0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x17:
	STS  _zadanie_I,R30
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x15
	RCALL __CWD1
	RCALL __CDF1
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x3FA33333
	RCALL __DIVF21
	RCALL __PUTD1S0
	RCALL __CFD1U
	STS  _indy_I,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x18:
	LDI  R26,0
	SBIC 0x10,1
	LDI  R26,1
	CPI  R26,LOW(0x0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x19:
	STS  _zadanie_U,R30
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x15
	RCALL __CWD1
	RCALL __CDF1
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x3FA33333
	RCALL __DIVF21
	RCALL __PUTD1S0
	RCALL __CFD1U
	STS  _indy_U,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1A:
	LDS  R26,_start
	RJMP SUBOPT_0x4

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1B:
	RCALL __EQB12
	AND  R30,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1C:
	RCALL _ADC_I
	RCALL _PWM_control_I
	RCALL _ADC_U
	RCALL _recoding
	RCALL _button
	RJMP _led_rejim


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __DIVF219
	RJMP __MINRES
__DIVF219:
	RJMP __MAXRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R17
	CLR  R18
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,32
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R20,R17
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R20,R17
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R21
	ROL  R18
	ROL  R19
	ROL  R1
	ROL  R26
	ROL  R27
	ROL  R24
	ROL  R20
	DEC  R25
	BRNE __DIVF212
	MOVW R30,R18
	MOV  R22,R1
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	TST  R22
	BRMI __DIVF215
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__EQB12:
	CP   R30,R26
	LDI  R30,1
	BREQ __EQB12T
	CLR  R30
__EQB12T:
	RET

__LTB12U:
	CP   R26,R30
	LDI  R30,1
	BRLO __LTB12U1
	CLR  R30
__LTB12U1:
	RET

__GTB12U:
	CP   R30,R26
	LDI  R30,1
	BRLO __GTB12U1
	CLR  R30
__GTB12U1:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETD1P_INC:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X+
	RET

__PUTDP1_DEC:
	ST   -X,R23
	ST   -X,R22
	ST   -X,R31
	ST   -X,R30
	RET

__PUTD1S0:
	ST   Y,R30
	STD  Y+1,R31
	STD  Y+2,R22
	STD  Y+3,R23
	RET

;END OF CODE MARKER
__END_OF_CODE:
